// ****************************************************************************
// copyright (c) 2000-2002 Horst Knorr <hk_classes@knoda.org>
// This file is part of the hk_classes library.
// This file may be distributed and/or modified under the terms of the
// GNU Library Public License version 2 as published by the Free Software
// Foundation and appearing in the file COPYING included in the
// packaging of this file.
// This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
// ****************************************************************************
//$Revision: 1.8 $
#include "hk_actionquery.h"
#include "hk_database.h"

hk_actionquery::hk_actionquery(hk_database* db)
{
#ifdef HK_DEBUG
    hkdebug("hk_actionquery::constructor");
#endif
    p_sql=NULL;
    p_length=0;
    p_database=NULL;
    p_database=db;
}


hk_actionquery::~hk_actionquery(void)
{
#ifdef HK_DEBUG
    hkdebug("hk_actionquery::destructor");
#endif
    p_database->ds_remove(this);

}


hk_data::enum_datasourcetypes hk_actionquery::type(void)
{
    return ds_actionquery;
}

void hk_actionquery::set_sql(const hk_string& s)
{
   set_sql(s.c_str(),s.size());

}


void hk_actionquery::set_sql(const char* s,unsigned long l)
{
#ifdef HK_DEBUG
    hkdebug("hk_actionquery::set_sql");
#endif
    p_length=l;
    if (driver_specific_sql(s)) p_sql=s;

}

const char* hk_actionquery::sql(void)
{
return p_sql;
}

bool hk_actionquery::execute(void)
{
#ifdef HK_DEBUG
    hkdebug("hk_actionquery::execute");
#endif
    return driver_specific_execute();
}


void   hk_actionquery::before_source_vanishes(void)
{
#ifdef HK_DEBUG
    hkdebug("hk_actionquery::before_source_vanishes");
#endif
//  p_database->ds_remove(this);
//  p_database=NULL;
}


bool    hk_actionquery::driver_specific_sql(const char*s)
{
    return false;
}

unsigned long hk_actionquery::length(void)
{
 return p_length;
}

